describe Inkcite::Renderer::Slant do

  before do
    @view = Inkcite::Email.new('test/project/').view(:development, :email)
  end

  it 'renders a top left slant' do
    Inkcite::Renderer.render('{slant width=600 height=30 top left}', @view).must_equal('<!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shapetype id="stl" path="m0,21600l21600,0,0,0xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="str" path="m0,0l21600,0,21600,21600xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="sbl" path="m0,0l21600,21600,0,21600xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="sbr" path="m0,21600l21600,21600,21600,0xe" xmlns:v="urn:schemas-microsoft-com:vml"/></div><![endif]--><table border=0 cellpadding=0 cellspacing=0 class="fill" style="width:600px" width=600><tr><td><div class="slant15" style="-webkit-transform:rotate(0.0005deg);border-color:#223344 transparent transparent #223344;border-style:solid;border-width:15px 300px;mso-hide:all"></div><!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shape fillcolor=#223344 stroked=f style="height:30px;mso-position-horizontal:center;width:600px" type="stl"><o:lock selection="t"/></v:shape></div><![endif]--></td></tr></table>')
  end

  it 'renders a top right slant' do
    Inkcite::Renderer.render('{slant width=600 height=30 top right}', @view).must_equal('<!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shapetype id="stl" path="m0,21600l21600,0,0,0xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="str" path="m0,0l21600,0,21600,21600xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="sbl" path="m0,0l21600,21600,0,21600xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="sbr" path="m0,21600l21600,21600,21600,0xe" xmlns:v="urn:schemas-microsoft-com:vml"/></div><![endif]--><table border=0 cellpadding=0 cellspacing=0 class="fill" style="width:600px" width=600><tr><td><div class="slant15" style="-webkit-transform:rotate(0.0005deg);border-color:#223344 #223344 transparent transparent;border-style:solid;border-width:15px 300px;mso-hide:all"></div><!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shape fillcolor=#223344 stroked=f style="height:30px;mso-position-horizontal:center;width:600px" type="str"><o:lock selection="t"/></v:shape></div><![endif]--></td></tr></table>')
  end

  it 'renders a bottom left slant' do
    Inkcite::Renderer.render('{slant width=600 height=30 bottom left}', @view).must_equal('<!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shapetype id="stl" path="m0,21600l21600,0,0,0xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="str" path="m0,0l21600,0,21600,21600xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="sbl" path="m0,0l21600,21600,0,21600xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="sbr" path="m0,21600l21600,21600,21600,0xe" xmlns:v="urn:schemas-microsoft-com:vml"/></div><![endif]--><table border=0 cellpadding=0 cellspacing=0 class="fill" style="width:600px" width=600><tr><td><div class="slant15" style="-webkit-transform:rotate(0.0005deg);border-color:transparent transparent #223344 #223344;border-style:solid;border-width:15px 300px;mso-hide:all"></div><!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shape fillcolor=#223344 stroked=f style="height:30px;mso-position-horizontal:center;width:600px" type="sbl"><o:lock selection="t"/></v:shape></div><![endif]--></td></tr></table>')
  end

  it 'renders a bottom right slant' do
    Inkcite::Renderer.render('{slant width=600 height=30 bottom right}', @view).must_equal('<!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shapetype id="stl" path="m0,21600l21600,0,0,0xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="str" path="m0,0l21600,0,21600,21600xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="sbl" path="m0,0l21600,21600,0,21600xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="sbr" path="m0,21600l21600,21600,21600,0xe" xmlns:v="urn:schemas-microsoft-com:vml"/></div><![endif]--><table border=0 cellpadding=0 cellspacing=0 class="fill" style="width:600px" width=600><tr><td><div class="slant15" style="-webkit-transform:rotate(0.0005deg);border-color:transparent #223344 #223344 transparent;border-style:solid;border-width:15px 300px;mso-hide:all"></div><!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shape fillcolor=#223344 stroked=f style="height:30px;mso-position-horizontal:center;width:600px" type="sbr"><o:lock selection="t"/></v:shape></div><![endif]--></td></tr></table>')
  end

  it 'renders only renders the VML shape declarations once' do
    Inkcite::Renderer.render('{slant width=600 height=30}{slant width=600 height=30 backward}', @view).must_equal('<!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shapetype id="stl" path="m0,21600l21600,0,0,0xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="str" path="m0,0l21600,0,21600,21600xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="sbl" path="m0,0l21600,21600,0,21600xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="sbr" path="m0,21600l21600,21600,21600,0xe" xmlns:v="urn:schemas-microsoft-com:vml"/></div><![endif]--><table border=0 cellpadding=0 cellspacing=0 class="fill" style="width:600px" width=600><tr><td><div class="slant15" style="-webkit-transform:rotate(0.0005deg);border-color:#223344 #223344 transparent transparent;border-style:solid;border-width:15px 300px;mso-hide:all"></div><!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shape fillcolor=#223344 stroked=f style="height:30px;mso-position-horizontal:center;width:600px" type="str"><o:lock selection="t"/></v:shape></div><![endif]--></td></tr></table><table border=0 cellpadding=0 cellspacing=0 class="fill" style="width:600px" width=600><tr><td><div class="slant15" style="-webkit-transform:rotate(0.0005deg);border-color:#223344 #223344 transparent transparent;border-style:solid;border-width:15px 300px;mso-hide:all"></div><!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shape fillcolor=#223344 stroked=f style="height:30px;mso-position-horizontal:center;width:600px" type="str"><o:lock selection="t"/></v:shape></div><![endif]--></td></tr></table>')
  end

  it 'supports a custom foreground color' do
    Inkcite::Renderer.render('{slant width=600 height=30 color=#f00}', @view).must_equal('<!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shapetype id="stl" path="m0,21600l21600,0,0,0xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="str" path="m0,0l21600,0,21600,21600xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="sbl" path="m0,0l21600,21600,0,21600xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="sbr" path="m0,21600l21600,21600,21600,0xe" xmlns:v="urn:schemas-microsoft-com:vml"/></div><![endif]--><table border=0 cellpadding=0 cellspacing=0 class="fill" style="width:600px" width=600><tr><td><div class="slant15" style="-webkit-transform:rotate(0.0005deg);border-color:#ff0000 #ff0000 transparent transparent;border-style:solid;border-width:15px 300px;mso-hide:all"></div><!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shape fillcolor=#ff0000 stroked=f style="height:30px;mso-position-horizontal:center;width:600px" type="str"><o:lock selection="t"/></v:shape></div><![endif]--></td></tr></table>')
  end

  it 'supports a custom background color' do
    Inkcite::Renderer.render('{slant width=600 height=30 bgcolor=#f00}', @view).must_equal('<!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shapetype id="stl" path="m0,21600l21600,0,0,0xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="str" path="m0,0l21600,0,21600,21600xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="sbl" path="m0,0l21600,21600,0,21600xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="sbr" path="m0,21600l21600,21600,21600,0xe" xmlns:v="urn:schemas-microsoft-com:vml"/></div><![endif]--><table bgcolor=#ff0000 border=0 cellpadding=0 cellspacing=0 class="fill" style="width:600px" width=600><tr><td><div class="slant15" style="-webkit-transform:rotate(0.0005deg);border-color:#223344 #223344 transparent transparent;border-style:solid;border-width:15px 300px;mso-hide:all"></div><!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shape fillcolor=#223344 stroked=f style="height:30px;mso-position-horizontal:center;width:600px" type="str"><o:lock selection="t"/></v:shape></div><![endif]--></td></tr></table>')
  end

  it 'supports custom dimensions' do
    Inkcite::Renderer.render('{slant width=400 height=60}', @view).must_equal('<!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shapetype id="stl" path="m0,21600l21600,0,0,0xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="str" path="m0,0l21600,0,21600,21600xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="sbl" path="m0,0l21600,21600,0,21600xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="sbr" path="m0,21600l21600,21600,21600,0xe" xmlns:v="urn:schemas-microsoft-com:vml"/></div><![endif]--><table border=0 cellpadding=0 cellspacing=0 class="fill" style="width:400px" width=400><tr><td><div class="slant30" style="-webkit-transform:rotate(0.0005deg);border-color:#223344 #223344 transparent transparent;border-style:solid;border-width:30px 200px;mso-hide:all"></div><!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shape fillcolor=#223344 stroked=f style="height:60px;mso-position-horizontal:center;width:400px" type="str"><o:lock selection="t"/></v:shape></div><![endif]--></td></tr></table>')
  end

  it 'supports disabling the VML fallback' do
    Inkcite::Renderer.render('{slant width=600 height=30 no-fallback}', @view).must_equal('<table border=0 cellpadding=0 cellspacing=0 class="fill" style="width:600px" width=600><tr><td><div class="slant15" style="-webkit-transform:rotate(0.0005deg);border-color:#223344 #223344 transparent transparent;border-style:solid;border-width:15px 300px;mso-hide:all"></div></td></tr></table>')
  end

  it 'supports disabling the width wrap' do
    Inkcite::Renderer.render('{slant width=600 height=30 no-wrap}', @view).must_equal('<!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shapetype id="stl" path="m0,21600l21600,0,0,0xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="str" path="m0,0l21600,0,21600,21600xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="sbl" path="m0,0l21600,21600,0,21600xe" xmlns:v="urn:schemas-microsoft-com:vml"/><v:shapetype id="sbr" path="m0,21600l21600,21600,21600,0xe" xmlns:v="urn:schemas-microsoft-com:vml"/></div><![endif]--><div class="slant15" style="-webkit-transform:rotate(0.0005deg);border-color:#223344 #223344 transparent transparent;border-style:solid;border-width:15px 300px;mso-hide:all"></div><!--[if lt mso 16]><div style="font-size:0;line-height:0"><v:shape fillcolor=#223344 stroked=f style="height:30px;mso-position-horizontal:center;width:600px" type="str"><o:lock selection="t"/></v:shape></div><![endif]-->')
  end

end
